'From SqueakNihongo6.1 of 17 April 2004 [latest update: #1] on 7 July 2004 at 9:58:49 am'!
"Change Set:		NihongoScamper
Date:			1 May 2004
Author:			ICHIKAWA, Yuji
Version:			0.4
ChangeLog:
#0.4 improved readability.
#0.3 added Automatic recognition among JIS, SJIS, EUC, and others.
#0.2 let the default coding be EUC. 
#0.1 initial release.
References:
-http://www.net.is.uec.ac.jp/~ueno/material/kanji/auto.html
-http://tohoho.wakusei.ne.jp/wwwkanji.htm
"
!

HtmlEntity subclass: #HtmlHead
	instanceVariableNames: ''
	classVariableNames: 'DefaultEncode '
	poolDictionaries: ''
	category: 'Network-HTML-Parser Entities'!

!EUCJPTextConverter class methodsFor: 'as yet unclassified' stamp: 'ich. 5/1/2004 16:47'!
checkCode: upperCharacter followed: lowerCharacter
	| u l |
	u _ upperCharacter asInteger.
	u < 16r80 ifTrue: [^ true].
	l _ lowerCharacter asInteger.
	(u = 16r8E) & (l between: 16rA0 and: 16rDF) ifTrue: [^ true]. "hankaku katakana"
	(u between: 16rA1 and: 16rFE) & (l between: 16rA1 and: 16rFE) ifTrue: [^ true].
	^ false.


! !

!EUCJPTextConverter class methodsFor: 'as yet unclassified' stamp: 'ich. 5/1/2004 18:07'!
isFirstByte: aCharacter
	^ (aCharacter asInteger = 16r8E) | (aCharacter asInteger between: 16rA1 and: 16rFE).
! !


!HtmlDocument methodsFor: 'as yet unclassified' stamp: 'ich. 4/17/2004 23:03'!
charset
	| result |
	result _ self head charset.
	^ result
		ifNotNil: [result]
		ifNil: [self asHtml guessJapaneseEncoding].
! !

!HtmlDocument methodsFor: 'as yet unclassified' stamp: 'ich. 4/11/2004 00:51'!
replaceAllTextsToMultiString
	| charset converter |
	charset _ self charset.
	charset ifNotNil:
		[TextConverter allSubclassesDo:
			[:each |
			(each encodingNames includes: charset asLowercase)
				ifTrue: [converter _ each new]]].
	self allSubentitiesDo:
		[:each |
		(each isMemberOf: HtmlTextEntity)
			ifTrue: [each replaceToMultiString: converter]].
! !


!HtmlFormatter methodsFor: 'formatting commands' stamp: 'ich. 5/24/2004 21:49'!
startListItem
	"begin a new list item"
	listTypes size = 0 ifTrue: [ ^self ].
	self ensureNewlines: 1.
	listTypes last = #unordered
		ifTrue: [ self addString: '・ ' ]
		ifFalse: [ self addString: (listLengths last + 1) printString.
			self addString: '. ' ].
	listLengths at: (listLengths size) put: (listLengths last + 1).!]lang[(161 1 161)0,5,0! !


!HtmlHead methodsFor: 'as yet unclassified' stamp: 'ich. 5/1/2004 16:49'!
charset
	self allSubentitiesDo:
		[:each |
		(each isMemberOf: HtmlMeta) ifTrue:
			[| retval |
			retval _ each charset.
			retval ifNotNil: [^ retval]]].
	^ nil.
! !


!HtmlMeta methodsFor: 'formatting' stamp: 'tak 7/5/2004 17:11'!
charset
	(self getAttribute: #'http-equiv')
		ifNil: [^ nil].
	(self getAttribute: #'http-equiv') asLowercase = 'content-type'
		ifFalse: [^ nil].
	((self getAttribute: #content)
		findTokens: '; ')
		do: [:each | (each beginsWith: 'charset')
				ifTrue: [^ (each findTokens: '= ')
						at: 2]].
	^ nil! !


!HtmlTextEntity methodsFor: 'access' stamp: 'ich. 4/11/2004 00:50'!
replaceToMultiString: aTextConverter
	aTextConverter
		ifNil: [self text: self text isoToSqueak] "Original Scamper transforms using isoToSqueak."
		ifNotNil: [self text: (self text convertFromWithConverter: aTextConverter)].
! !


!Scamper methodsFor: 'document handling' stamp: 'tak 6/23/2004 22:50'!
displayTextHtmlPage: newSource
	"HTML page--format it"
	| formatter bgimageUrl bgimageDoc bgimage |
	currentUrl _ newSource url.
	pageSource _ newSource content.
	self status: 'parsing...' translated.
	document _ HtmlParser parse: (ReadStream on: pageSource).
	document _ HtmlParser parse: document asHtmlAfterScripts.
	document replaceAllTextsToMultiString.
	self status: 'laying out...' translated.
	formatter _ HtmlFormatter preferredFormatterClass new.
	formatter browser: self.
	formatter baseUrl: currentUrl.
	document addToFormatter: formatter.

	formattedPage _ formatter text.
	(bgimageUrl _ document body background)
		ifNotNil:
			[bgimageDoc _ (bgimageUrl asUrlRelativeTo: currentUrl) retrieveContents.
			[bgimage _ ImageReadWriter formFromStream: bgimageDoc contentStream binary]
				ifError: [:err :rcvr | "ignore" bgimage _ nil]].
	bgimage
		ifNotNil: [backgroundColor _ bgimage]
		ifNil: [backgroundColor _ Color fromString: document body bgcolor].
	currentUrl fragment
		ifNil: [ currentAnchorLocation _ nil ]
		ifNotNil: [ currentAnchorLocation _
				formatter anchorLocations 
					at: currentUrl fragment asLowercase
					ifAbsent: [ nil ] ].

	self startDownloadingMorphState: (formatter incompleteMorphs).

	self changeAll: 	#(currentUrl relabel hasLint lint backgroundColor formattedPage formattedPageSelection).
	self status: 'done.' translated.
	"pardon this horrible hack...(tk)"
	(currentUrl authority beginsWith: 'ets.freetranslation.com') ifTrue: [
		self status: 'done.
**** Please Scroll Down To See Your Results ****' translated].
	^true! !


!ShiftJISTextConverter class methodsFor: 'as yet unclassified' stamp: 'ich. 5/1/2004 16:52'!
checkCode: upperCharacter followed: lowerCharacter
	| u l |
	u _ upperCharacter asInteger.
	u < 16r80 ifTrue: [^ true].
	l _ lowerCharacter asInteger.
	((u between: 16r81 and: 16r9F) | (u between: 16rE0 and: 16rFF))
		& ((l between: 16r40 and: 16rFC) & (l ~= 16r7F)) ifTrue: [^ true].
	^ false.
! !

!ShiftJISTextConverter class methodsFor: 'as yet unclassified' stamp: 'ich. 4/11/2004 00:33'!
encodingNames 

	^ #('shift-jis' 'shift_jis' 'sjis', 'x-sjis') copy
! !

!ShiftJISTextConverter class methodsFor: 'as yet unclassified' stamp: 'ich. 5/1/2004 16:30'!
isFirstByte: aCharacter
	^ (aCharacter asInteger between: 16r81 and: 16r9F) | (aCharacter asInteger between: 16rE0 and: 16rEF).
! !


!String methodsFor: 'testing' stamp: 'ich. 5/8/2004 16:22'!
mayBeJIS
	| esc |
	esc _ Character escape asString.
	^ (self includesSubString: esc , '$@') or:
		[(self includesSubString: esc , '$B') or:
			[self includesSubString: esc , '$(D']].
! !

!String methodsFor: 'encoding' stamp: 'ich. 5/1/2004 18:16'!
guessJapaneseEncoding
	| stream isEuc isSjis eucFirstByte sjisFirstByte |
	self mayBeJIS ifTrue: [^ 'iso-2022-jp'].
		
	stream _ ReadStream on: self.
	isEuc _ nil.
	isSjis _ nil.
	eucFirstByte _ nil.
	sjisFirstByte _ nil.
	[stream atEnd] whileFalse:
		[| char |
		char _ stream next.
		eucFirstByte
			ifNil:
				[(EUCJPTextConverter isFirstByte: char) ifTrue:
					[eucFirstByte _ char.
					isEuc ifNil: [isEuc _ true]]]
			ifNotNil:
				[(EUCJPTextConverter checkCode: eucFirstByte followed: char) ifFalse:
					[isEuc _ false].
				eucFirstByte _ nil].
		sjisFirstByte
			ifNil:
				[(ShiftJISTextConverter isFirstByte: char) ifTrue:
					[sjisFirstByte _ char.
					isSjis ifNil: [isSjis _ true]]]
			ifNotNil:
				[(ShiftJISTextConverter checkCode: sjisFirstByte followed: char) ifFalse:
					[isSjis _ false].
				sjisFirstByte _ nil]].

	(isEuc isNil & isSjis isNil) ifTrue: [^ nil]. "It means ASCII."
	(isEuc notNil and: [isEuc]) ifTrue: [^ 'eucjp']. "EUC has high priority."
	(isSjis notNil and: [isSjis]) ifTrue: [^ 'sjis'].
	^ nil. "unrecognized code"
! !

HtmlEntity subclass: #HtmlHead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-HTML-Parser Entities'