'From SqueakNihongo6.1 of 17 April 2004 [latest update: #1] on 7 July 2004 at 9:58:49 am'!
"Change Set:		ScamperBugFix
Date:			6 May 2004
Author:			ICHIKAWA, Yuji
Version:			0.3
ChangeLog:
#0.3 is same as 0.2 but used the method containingWindow rather than keeping the morph to the instance variable.
#0.2 enables to load remote project files repeatedly.
#0.1 enables to load remote project files"!

Model subclass: #Scamper
	instanceVariableNames: 'status currentUrl pageSource document formattedPage downloadingProcess documentQueue recentDocuments currentAnchorLocation currentUrlIndex backgroundColor bookmark bookDir bindings '
	classVariableNames: 'StartUrl '
	poolDictionaries: ''
	category: 'Network-Web Browser'!

!Scamper methodsFor: 'changing page' stamp: 'tak 6/23/2004 22:05'!
jumpToAbsoluteUrl: urlText
	"start downloading a new page.  The page source is downloaded in a background thread"
	|  newUrl newSource morph |

	self stopEverything.

	"get the new url"
	newUrl _ urlText asUrl.


	"if it fundamentally doesn't fit the pages-and-contents model used internally, spawn off an external viewer for it"
	newUrl hasContents ifFalse: [ newUrl activate.  ^true ].

	"fork a Process to do the actual downloading, parsing, and formatting.  It's results will be picked up in #step"
	self status: ('downloading {1}...' translated format:{newUrl toText}).

	downloadingProcess _ [ 
	  	newSource _ [ newUrl retrieveContentsForBrowser: self ] ifError: [ :msg :ctx |
			MIMEDocument contentType: 'text/plain' content: msg ].

		newSource 
			ifNil: [ newSource _ MIMEDocument contentType: 'text/plain' content: 'Error retrieving this URL' translated].

			newSource url ifNil: [
				newSource _ MIMEDocument contentType: newSource contentType  content: newSource content  url: newUrl ].

			documentQueue nextPut: newSource.
			downloadingProcess _ nil.
	] newProcess.

	downloadingProcess resume.

	[recentDocuments size > currentUrlIndex] whileTrue: [
		"delete all elements in recentDocuments after currentUrlIndex"
		recentDocuments removeLast.
	].
	currentUrlIndex _ currentUrlIndex + 1.
	morph _ self containingWindow.
	morph ifNotNil: [morph start].

	^true! !

!Scamper methodsFor: 'creation' stamp: 'ccn 6/28/2000 19:52'!
openAsMorph

	^self morphicWindow openInWorld
! !


!ServerDirectory methodsFor: 'file directory' stamp: 'ich. 5/2/2004 00:11'!
readOnlyFileNamed: aName
	"If the file exists, answer a read-only RemoteFileStream on it.  aName is directory path, and does include name of the server.  Or it can just be a fileName.  For now, pre-read the file."

	| rFile |

	rFile _ self asServerFileNamed: aName.
	rFile readOnly.
	rFile isTypeFile ifTrue: [
		^ FileStream oldFileNamed: (rFile fileNameRelativeTo: self)].

	^ rFile streamOnBeginning! !


!ServerFile methodsFor: 'as yet unclassified' stamp: 'ich. 5/2/2004 00:21'!
downloadUrl
	"The url under which files will be accessible."
	^ self altUrl
		ifNil: [self realUrl]
		ifNotNil: [self altUrl].

! !

!ServerFile methodsFor: 'as yet unclassified' stamp: 'ich. 5/2/2004 00:15'!
getInto: dataStream
	self getFileNamed: '' into: dataStream.
! !

!ServerFile methodsFor: 'as yet unclassified' stamp: 'ich. 5/2/2004 00:28'!
streamOnBeginning
	| remoteStrm |
	remoteStrm _ RemoteFileStream on: (String new: 2000).
	remoteStrm remoteFile: self.
	self getInto: remoteStrm.	"prefetch data"
	^ remoteStrm! !

