'From SqueakNihongo6.1 of 17 April 2004 [latest update: #1] on 7 July 2004 at 9:58:49 am'!
"Change Set:		ScamperFix-20040705
Date:			5 July 2004
Author:			Takashi Yamamiya

Fix size of contents when posting.
Fix first newline of text area.
Some visual property
"!


!AbstractString methodsFor: '*network-HTML' stamp: 'tak 7/5/2004 21:22'!
replaceHtmlCharRefs

        | pos ampIndex scIndex special specialValue outString outPos newOutPos |

        outString _ String new: self size.
        outPos _ 0.

        pos _ 1.
        
        [ pos <= self size ] whileTrue: [ 
                "read up to the next ampersand"
                ampIndex _ self indexOf: $& startingAt: pos ifAbsent: [0].
                
                ampIndex = 0 ifTrue: [
                        pos = 1 ifTrue: [ ^self ] ifFalse: [ ampIndex _ self size+1 ] ].

                newOutPos _ outPos + ampIndex - pos.
                outString
                        replaceFrom: outPos + 1
                        to: newOutPos
                        with: self
                        startingAt: pos.
                outPos _ newOutPos.
                pos _ ampIndex.

                ampIndex <= self size ifTrue: [
                        "find the $;"
                        scIndex _ self indexOf: $; startingAt: ampIndex ifAbsent: [ self size + 1 ].

                        special _ self copyFrom: ampIndex+1 to: scIndex-1.       
                        specialValue _ HtmlEntity valueOfHtmlEntity: special. 

                        specialValue
                                ifNil: [
                                        "not a recognized entity.  wite it back"
								  scIndex > self size ifTrue: [ scIndex _ self size ].

                                        newOutPos _ outPos + scIndex - ampIndex + 1.
                                        outString
                                                replaceFrom: outPos+1
                                                to: newOutPos
                                                with: self
                                                startingAt: ampIndex.
                                        outPos _ newOutPos.]
                                ifNotNil: [
                                        outPos _ outPos + 1.
                                        outString at: outPos put: specialValue isoToSqueak.].
                        
                        pos _ scIndex + 1. ]. ].


        ^outString copyFrom: 1 to: outPos! !


!DownloadingImageMorph methodsFor: 'as yet unclassified' stamp: 'tak 4/25/2004 11:15'!
step
	| doc |
	downloadQueue size > 0 ifTrue: [
		doc _ downloadQueue next.
		(doc notNil and: [doc mainType = 'image' ])
		ifTrue: [
			[image _ ImageReadWriter  formFromStream: doc contentStream binary]
				ifError: [:err :rcvr | "ignore" image _ nil].
			self setContents ] ].! !


!FileUrl methodsFor: 'downloading' stamp: 'tak 4/25/2004 11:14'!
retrieveContents
	| file pathString s type entries |
	pathString _ self pathForFile.
	file _ [StandardFileStream readOnlyFileNamed: pathString] 
			on: FileDoesNotExistException do:[:ex| ex return: nil].
	file ifNotNil: [
		type _ file mimeTypes.
		type ifNotNil:[type _ type first].
		type ifNil:[MIMEDocument guessTypeFromName: self path last].
		^MIMELocalFileDocument 
			contentType: type
			contentStream: file].

	"see if it's a directory..."
	entries _ [(FileDirectory on: pathString) entries] 
				on: InvalidDirectoryError do:[:ex| ex return: nil].
	entries ifNil:[^nil].

	s _ WriteStream on: String new.
	(pathString endsWith: '/') ifFalse: [ pathString _ pathString, '/' ].
	s nextPutAll: '<title>Directory Listing for ', pathString, '</title>'.
	s nextPutAll: '<h1>Directory Listing for ', pathString, '</h1>'.
	s nextPutAll: '<ul>'.
	s cr.
	entries do: [ :entry |
		s nextPutAll: '<li><a href="'.
		s nextPutAll: entry name.
		s nextPutAll: '">'.
		s nextPutAll: entry name.
		s nextPutAll: '</a>'.
		s cr. ].
	s nextPutAll: '</ul>'.
	^MIMEDocument  contentType: 'text/html'  content: s contents  url: ('file:', pathString)! !


!HTTPSocket class methodsFor: 'utilities' stamp: 'tak 7/5/2004 16:50'!
httpPostDocument: url  args: argsDict accept: mimeType request: requestString
	"like httpGET, except it does a POST instead of a GET.  POST allows data to be uploaded"

	| s header length page list firstData aStream type newUrl httpUrl argString size |
	Socket initializeNetwork.
	httpUrl _ Url absoluteFromText: url.
	page _ httpUrl fullPath.
	"add arguments"
	argString _ argsDict
		ifNotNil: [argString _ self argString: argsDict]
		ifNil: [''].
	page _ page, argString.

	s _ HTTPSocket new. 
	s _ self initHTTPSocket: httpUrl wait: (self deadlineSecs: 30) ifError: [:errorString | ^errorString].
	size _ argString size.
	argString first = $? ifTrue: [size _ size - 1].
	s sendCommand: 'POST ', page, ' HTTP/1.0', CrLf, 
		(mimeType ifNotNil: ['ACCEPT: ', mimeType, CrLf] ifNil: ['']),
		'ACCEPT: text/html', CrLf,	"Always accept plain text"
		HTTPBlabEmail,	"may be empty"
		requestString,	"extra user request. Authorization"
		self userAgentString, CrLf,
		'Content-type: application/x-www-form-urlencoded', CrLf,
		'Content-length: ', size printString, CrLf,
		'Host: ', httpUrl authority, CrLf.  "blank line automatically added"
	argString first = $? ifTrue: [ argString _ argString copyFrom: 2 to: argString size].
	"umur - IE sends argString without a $? and swiki expects so"
	s sendCommand: argString.

	"get the header of the reply"
	list _ s getResponseUpTo: CrLf, CrLf ignoring: (String with: CR).	"list = header, CrLf, CrLf, beginningOfData"
	header _ list at: 1.
	"Transcript show: page; cr; show: argsStream contents; cr; show: header; cr."
	firstData _ list at: 3.

	"dig out some headers"
	s header: header.
	length _ s getHeader: 'content-length'.
	length ifNotNil: [ length _ length asNumber ].
	type _ s getHeader: 'content-type'.
	s responseCode first = $3 ifTrue: [
		newUrl _ s getHeader: 'location'.
		newUrl ifNotNil: [
			"umur 6/25/2003 12:58 - If newUrl is relative then we need to make it absolute."
			newUrl _ (httpUrl newFromRelativeText: newUrl) asString.
			self flag: #refactor. "get, post, postmultipart are almost doing the same stuff".
			s destroy.
			"^self httpPostDocument: newUrl  args: argsDict  accept: mimeType"
			^self httpGetDocument: newUrl accept: mimeType ] ].

	aStream _ s getRestOfBuffer: firstData totalLength: length.
	s responseCode = '401' ifTrue: [^ header, aStream contents].
	s destroy.	"Always OK to destroy!!"

	^ MIMEDocument contentType: type  content: aStream contents url: url!
]style[(77 549 47 464 150 561 229 369)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !


!HtmlForm methodsFor: 'attributes' stamp: 'ls 7/17/1998 00:40'!
url
	"url to submit to"
	^self getAttribute: 'action' default: nil.  ! !


!HtmlInput methodsFor: 'formatting' stamp: 'tak 7/5/2004 16:55'!
addTextInputToFormatter: formatter
	"is it a submit button?"
	| inputMorph size |
	inputMorph _ PluggableTextMorph on: StringHolder new text: #contents accept: #acceptContents:.
	inputMorph hideScrollBarIndefinitely.
	inputMorph acceptOnCR: true.
	self type = 'password'
		ifTrue: [inputMorph font: (StrikeFont passwordFontSize: 12)].
	size _ (self getAttribute: 'size' default: '12') asNumber.
	inputMorph extent: (size*10@20).
	formatter addMorph: inputMorph.
	formatter currentFormData addInput:
		(TextInput name: self name defaultValue: self defaultValue  textMorph: inputMorph).! !


!HtmlTextArea methodsFor: 'contents' stamp: 'tak 7/5/2004 16:20'!
textualContents
	| string |
	string _ super textualContents.
	(string isEmpty not
			and: [string first = Character cr])
		ifTrue: [string _ string allButFirst].
	^ string! !


!Scamper methodsFor: 'user interface' stamp: 'dgd 10/28/2003 13:48'!
readUrlFromFile: aFile
	| oldFile url |
	oldFile _ FileStream oldFileOrNoneNamed: aFile.
	oldFile isBinary 
		ifTrue:[ self error: 'not url file' translated]
		ifFalse:[url _ (oldFile contentsOfEntireFile) withBlanksTrimmed.
				url =='' ifTrue:[ self error: 'blank file: url not exist' translated].
				^url asUrl].
	! !

!Scamper methodsFor: 'window definition' stamp: 'tak 7/5/2004 14:09'!
statusPane
	"Create and return the browser status pane."
	^ (PluggableTextMorph
		on: self
		text: #status
		accept: nil) hideScrollBarIndefinitely; yourself! !

!Scamper methodsFor: 'window definition' stamp: 'tak 7/5/2004 14:07'!
urlEditPane
	"Create and return the URL edit pane."
	^ (PluggableTextMorph
		on: self
		text: #currentUrl
		accept: #jumpToAbsoluteUrl:) acceptOnCR: true;
		 hideScrollBarIndefinitely;
		 yourself! !

!Scamper methodsFor: 'changing page' stamp: 'dgd 10/28/2003 13:35'!
submitFormWithInputs: inputs url: url method: method encoding: encoding
	"Submit the given form with the provided inputs, url, method, and encoding"

	| newUrl newSource | 
	self stopEverything.

	(method asLowercase ~= 'get' and: [ method asLowercase ~= 'post' ]) ifTrue:
		[self inform: ('unknown FORM method: {1}' translated format:{method}).
		^false ].

	newUrl _ url asUrlRelativeTo: currentUrl.	

	newUrl schemeName ~= 'http' ifTrue:
		[self inform: 'I can only submit forms via HTTP' translated.
		^ false].

	self status: 'submitting form...' translated.

	downloadingProcess _
		[method asLowercase = 'get' 
			ifTrue: [newSource _ newUrl retrieveContentsArgs: inputs] 
			ifFalse:
				[encoding = MIMEDocument contentTypeMultipart
					ifTrue: [newSource _ newUrl postMultipartFormArgs: inputs]
					ifFalse: [newSource _ newUrl postFormArgs: inputs]].
		documentQueue nextPut:  newSource.

		downloadingProcess _ nil] newProcess.

	downloadingProcess resume.
	^ true
! !


!TechoInfo class methodsFor: 'instance creation' stamp: 'tak 7/7/2004 09:58'!
scamperPackage
"Includes ...
Scamper
http://map1.squeakfoundation.org/sm/accountbyid/a6930213-b578-49b1-862e-228cc5ab39e7/files/Scamper-md.3.mcz
http://map1.squeakfoundation.org/sm/accountbyid/a6930213-b578-49b1-862e-228cc5ab39e7/files/Network-HTML-md.3.mcz

ScamperScript
http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-June/001658.html
ScamperScript.2.cs

http://ich.homelinux.net:8080/squeak/uploads/48/ScamperBugFix.2.cs
http://ich.homelinux.net:8080/squeak/uploads/NihongoScamper.1.cs

http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-April/001433.html
ZipArchiveMember-compressDataTo

http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-April/001549.html
withSeparatorsCompacted-tak

ScamperWorkspace-2004-07-05
ScamperFix-20040705
"
	| info |
	info _ self new.
	info prerequisiteChangeSets: #('Network-HTML-md.3' 'Scamper-md.3' 'ScamperScript' 'ScamperBugFix' 'NihongoScamper' 'withSeparatorsCompacted-tak' 'ZipArchiveMember-compressDataTo' 'ScamperWorkspace-20040707' 'ScamperFix-20040705').
	^ info! !

