'From SqueakNihongo6.1 of 17 April 2004 [latest update: #1] on 7 July 2004 at 9:58:49 am'!
"Change Set:		SmallScript
Date:			24 May 2004
Author:			ICHIKAWA, Yuji
Version:			0.1
ChangeLog:
#0.1 initial version.

Install:
Install the change set and do 'HtmlTag initialize.'
"!

HtmlBlockEntity subclass: #HtmlScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-HTML-Parser Entities'!

!HtmlEntity methodsFor: 'converting' stamp: 'ich. 5/24/2004 09:31'!
asHtmlAfterScripts
	| aStream |
	aStream := WriteStream on: ''.
	self doScriptOn: aStream indent: 0.
	^aStream contents.
! !

!HtmlEntity methodsFor: 'as yet unclassified' stamp: 'ich. 5/24/2004 09:22'!
doScriptOn: aStream indent: indent
	aStream next: indent put: $ ;
	nextPutAll: '<';
	 nextPutAll: self tagName.
	self attributes associationsDo: [:assoc | aStream space; nextPutAll: assoc key; nextPutAll: '="'; nextPutAll: assoc value; nextPutAll: '"'].
	aStream nextPut: $>;
	 cr.
	contents do: [:entity | entity doScriptOn: aStream indent: indent + 1].
	aStream nextPutAll: '</'; nextPutAll: self tagName; nextPutAll: '>'.
! !


!HtmlScript methodsFor: 'testing' stamp: 'ich. 5/23/2004 22:53'!
mayContain: anEntity
	^anEntity isComment.
! !

!HtmlScript methodsFor: 'testing' stamp: 'ich. 5/23/2004 22:53'!
tagName
	^'script'.
! !

!HtmlScript methodsFor: 'as yet unclassified' stamp: 'ich. 5/24/2004 12:22'!
doIt
	| result |
	result _ Compiler evaluate: self script.
	^ result.
! !

!HtmlScript methodsFor: 'as yet unclassified' stamp: 'ich. 5/24/2004 09:26'!
doScriptOn: aStream indent: indent
	aStream next: indent put: $ ;
		nextPutAll: self doIt asString;
		cr.
! !

!HtmlScript methodsFor: 'as yet unclassified' stamp: 'ich. 6/22/2004 23:51'!
script
	| script commentStart commentEnd |
	(self getAttribute: #type) = 'text/smalltalk' ifFalse: [^ ''].
	commentStart _ '<!!--'.
	commentEnd _ '//-->'.
	script _ 'self halt: ''ScamperScript''.'.
	self subEntities do:
		[:each | | startIndex endIndex content |
		startIndex _ each commentText findString: commentStart.
		endIndex _ each commentText findString: commentEnd.
		(startIndex = 0) | (endIndex = 0)
			ifTrue: [content _ each commentText]
			ifFalse:
				[content _ each commentText
					copyFrom: startIndex + commentStart size
					to: endIndex - 1].
		script _ script , content].
	^ script.
! !


!HtmlTag class methodsFor: 'parser support' stamp: 'ich. 5/23/2004 22:59'!
entityClasses
	"a Dictionary mapping tag names into the correct entity class"
	"EntityClasses _ nil"

	EntityClasses isNil ifFalse: [ ^EntityClasses ].

	EntityClasses _ Dictionary new.

	#( 
		script	HtmlScript
		frameset	HtmlFrame
		frame	HtmlFrame

		title		HtmlTitle
		style	HtmlStyle
		meta	HtmlMeta

		p		HtmlParagraph
		form	HtmlForm
		blockquote	HtmlBlockQuote

		input	HtmlInput
		textarea	HtmlTextArea
		select	HtmlSelect
		optgroup	HtmlOptionGroup
		option		HtmlOption

		img		HtmlImage
		embed	HtmlEmbedded
		noembed	HtmlNoEmbed
		a		HtmlAnchor
		br		HtmlBreak

		map	HtmlMap
		area	HtmlArea

		li		HtmlListItem
		dd		HtmlDefinitionDefinition
		dt		HtmlDefinitionTerm

		ol		HtmlOrderedList
		ul		HtmlUnorderedList
		dl		HtmlDefinitionList

		h1		HtmlHeader
		h2		HtmlHeader
		h3		HtmlHeader
		h4		HtmlHeader
		h5		HtmlHeader
		h6		HtmlHeader

		hr		HtmlHorizontalRule

		strong	HtmlBoldEntity
		b		HtmlBoldEntity

		em		HtmlItalicsEntity
		i		HtmlItalicsEntity
		dfn 	HtmlItalicsEntity

		u		HtmlUnderlineEntity 

		tt		HtmlFixedWidthEntity
		kbd		HtmlFixedWidthEntity		

		strike	HtmlStrikeEntity

		big		HtmlBiggerFontEntity
		small	HtmlSmallerFontEntity

		sub		HtmlSubscript
		sup		HtmlSuperscript

		font	HtmlFontEntity

		pre		HtmlPreformattedRegion
 
		table	HtmlTable
		tr		HtmlTableRow
		td		HtmlTableDataItem 
		th		HtmlTableHeader
		) pairsDo: [ 
			:tagName :className |
			EntityClasses at: tagName asString put: (Smalltalk at: className) ].

	^EntityClasses ! !


!HtmlTextEntity methodsFor: 'printing' stamp: 'ich. 5/24/2004 10:33'!
doScriptOn: aStream indent: indent 
	self printHtmlOn: aStream indent: indent.
! !

!HtmlTextEntity methodsFor: 'printing' stamp: 'ich. 5/24/2004 11:30'!
printHtmlOn: aStream indent: indent 
	text do:
		[:each | 
		each = $<
			ifTrue: [aStream nextPutAll: '&lt;'.]
			ifFalse:
				[each = $>
					ifTrue: [aStream nextPutAll: '&gt;'.]
					ifFalse: [aStream nextPut: each]]].
! !


!Scamper methodsFor: 'document handling' stamp: 'tak 6/23/2004 22:50'!
displayTextHtmlPage: newSource
	"HTML page--format it"
	| formatter bgimageUrl bgimageDoc bgimage |
	currentUrl _ newSource url.
	pageSource _ newSource content.
	self status: 'parsing...' translated.
	document _ HtmlParser parse: (ReadStream on: pageSource).
	document _ HtmlParser parse: document asHtmlAfterScripts.
	document replaceAllTextsToMultiString.
	self status: 'laying out...' translated.
	formatter _ HtmlFormatter preferredFormatterClass new.
	formatter browser: self.
	formatter baseUrl: currentUrl.
	document addToFormatter: formatter.

	formattedPage _ formatter text.
	(bgimageUrl _ document body background)
		ifNotNil:
			[bgimageDoc _ (bgimageUrl asUrlRelativeTo: currentUrl) retrieveContents.
			[bgimage _ ImageReadWriter formFromStream: bgimageDoc contentStream binary]
				ifError: [:err :rcvr | "ignore" bgimage _ nil]].
	bgimage
		ifNotNil: [backgroundColor _ bgimage]
		ifNil: [backgroundColor _ Color fromString: document body bgcolor].
	currentUrl fragment
		ifNil: [ currentAnchorLocation _ nil ]
		ifNotNil: [ currentAnchorLocation _
				formatter anchorLocations 
					at: currentUrl fragment asLowercase
					ifAbsent: [ nil ] ].

	self startDownloadingMorphState: (formatter incompleteMorphs).

	self changeAll: 	#(currentUrl relabel hasLint lint backgroundColor formattedPage formattedPageSelection).
	self status: 'done.' translated.
	"pardon this horrible hack...(tk)"
	(currentUrl authority beginsWith: 'ets.freetranslation.com') ifTrue: [
		self status: 'done.
**** Please Scroll Down To See Your Results ****' translated].
	^true! !

