SystemOrganization addCategory: #'Techo-HTTP'!
SystemOrganization addCategory: #'Techo-Base'!


Workspace subclass: #Techo
	instanceVariableNames: 'location entries listIndex sortMode sortBlocks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-Base'!

Techo subclass: #TechoAbee3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-HTTP'!

Object subclass: #TechoEntry
	instanceVariableNames: 'summary selectionInterval '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-Base'!

TechoEntry subclass: #TechoAbee3Entry
	instanceVariableNames: 'title date author description url urlText '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-HTTP'!

TechoEntry subclass: #TechoFileEntry
	instanceVariableNames: 'fileName fileEntry '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-Base'!

Techo subclass: #TechoHatenaDiary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-HTTP'!

TechoEntry subclass: #TechoHatenaDiaryEntry
	instanceVariableNames: 'url '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-HTTP'!

Techo subclass: #TechoHowm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-Base'!

PackageInfo subclass: #TechoInfo
	instanceVariableNames: 'prerequisiteChangeSets '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-Base'!

TestCase subclass: #TechoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Techo-Base'!

Techo class
	instanceVariableNames: 'location '!

TechoAbee3 class
	instanceVariableNames: ''!

TechoEntry class
	instanceVariableNames: ''!

TechoAbee3Entry class
	instanceVariableNames: ''!

TechoFileEntry class
	instanceVariableNames: ''!

TechoHatenaDiary class
	instanceVariableNames: ''!

TechoHatenaDiaryEntry class
	instanceVariableNames: ''!

TechoHowm class
	instanceVariableNames: ''!

TechoInfo class
	instanceVariableNames: ''!

TechoTest class
	instanceVariableNames: ''!


!Techo commentStamp: 'tak 5/14/2004 12:12' prior: 0!
I am a simple editor for daily note.
I am inspired by emacs howm and kami 2001.

Techo open.

contents		NOT USE (for PluggableTextMorph's bug(???))
location	String	-- resource location
entries		a collection of KamiEntry -- pages
listIndex		Number -- current selection index of list
sortMode	Symbol -- #name or #time
sortBlocks	Dictionary -- see Techo>>initSortBlocks

TODO:
regexp search
wiki

Bugs:
Sorting is not supported TechoAbee3 and TechoHatenaDiary.

Change log:
2004-05-14
Entry sort.
Support Squeak 3.2.

2004-04-26
Support English image.

2004-04-23
Techo is as Workspace.

2004-04-21
	Grep (It's actually not REGEXP)

2004-04-18
	Support project okiba

2004-04-17
	Support Hatena Diary.
	Automatic updating like inspecter's stepping mechanism.
	Select first entry when startup.

2004-04-16
	Support Nihongo4

2004-04-14
	Add test case.
	Umezawa-san's code for delete entry.
!

!TechoAbee3 commentStamp: 'tak 4/18/2004 11:00' prior: 0!
TechoAbee3 open!

!TechoFileEntry commentStamp: 'tak 4/17/2004 12:17' prior: 0!
I represented a page of kami.

fileName	String	-- full path of this entry
fileEntry	FileEntry --!

!TechoHatenaDiary commentStamp: 'tak 4/18/2004 00:22' prior: 0!
TechoHatenaDiary open.

It needs Scamper and ichikawa-san's nihongo patch.!

!TechoInfo commentStamp: 'tak 4/21/2004 01:20' prior: 0!
self fileOutAllTecho!

!TechoTest commentStamp: 'tak 4/16/2004 23:32' prior: 0!
I am a test case for Techo.

Some useful other tests (benchmark) is in class side.
TestBrowser open.
!

!HtmlEntity methodsFor: '*techo-http' stamp: 'tak 4/18/2004 10:04'!
@ aString
	"first tag named aString"
	self
		allSubentitiesDo: [:e | e tagName = aString
				ifTrue: [^ e]].
	^ nil! !

!Techo methodsFor: 'actions' stamp: 'tak 4/20/2004 16:03'!
acceptContents: aString 
	| entry |
	super contents: aString.
	entry _ (self selectedEntry
		ifNil: [self newEntry]).
	entry contents: aString.
	listIndex _ 1.
	entries _ nil.
	self listChanged.
	self changed: #relabel.
	^ true! !

!TechoInfo class methodsFor: 'class initialization' stamp: 'tak 4/26/2004 08:23'!
addMethodForMultiByteFileStream
	"This is for SqueakNihongo6"
	"self addMethodForMultiByteFileStream"
	(Smalltalk includesKey: #MultiByteFileStream)
		ifTrue: [(Smalltalk at: #MultiByteFileStream) class
				compileInobtrusively: 'lineEndDefault
	^ LineEndDefault
'
				classified: 'techo compatibility']! !

!Techo methodsFor: 'initialization' stamp: 'tak 4/17/2004 01:38'!
buildButton
	"Techo open."
	| row |
	row _ Morph new.
	row  layoutPolicy: TableLayout new;
	listDirection: #leftToRight;
	  hResizing: #spaceFill;
	  vResizing: #spaceFill.

	self buttonQuads
		do: [:quad | 
			| button | 
			button _ SimpleButtonMorph new target: self.
			button borderWidth: 0.
			button color: Color transparent.
			button actionSelector: quad second.
			button label: quad first.
			button setBalloonText: quad fourth.
			row addMorphBack: button].
	^row.! !

!Techo class methodsFor: 'fileIn/Out' stamp: 'tak 4/19/2004 22:12'!
buildScamperPackage
	"self buildScamperPackage"
! !

!TechoTest class methodsFor: 'testing' stamp: 'tak 4/13/2004 22:26'!
buildTestDirectory
	"self buildTestDirectory"
	"self new tearDown"
	| techo period step |
	techo _ Techo on: 'techoTest'.
	period _ 365 * 1. "1 years"
	step _ 60 * 60 * 24 / 5. "5 file a day"

	1 to: period * 60 * 60 * 24 by: step do: [ :second |
		| entry |
		entry _ techo newEntryFor: (TimeStamp fromSeconds: second).
		entry contents: 'hello!!', second asString]! !

!Techo methodsFor: 'initialization' stamp: 'tak 4/24/2004 12:13'!
buildWindow
	"self open"
	| window fileListMorph |
	window _ SystemWindow new model: self.
	fileListMorph _ PluggableListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex:
				menu: #listMenu:.
	window
		addMorph: fileListMorph
		frame: (0 @ 0.0 corner: 1 @ 0.2).
	window
		addMorph: ((PluggableTextMorph
				on: self
				text: #contents
				accept: #acceptContents:
				readSelection: #selectionInterval
				menu: #codePaneMenu:shifted:)
				askBeforeDiscardingEdits: true)
		frame: (0 @ 0.2 corner: 1 @ 1).
	window paneColor: (Color r: 0.7 g: 0.7 b: 1.0).
	self entries notEmpty
		ifTrue: [listIndex _ 1].
	self changed: #list.
	self changed: #contents.
	^ window! !

!Techo methodsFor: 'constants' stamp: 'tak 4/17/2004 22:22'!
buttonQuads
	^ #(
"		(' new ' makeNewEntry nil 'make new entry')"
		(' setup ' setupLocation nil 'setup directory')
		)! !

!Techo methodsFor: 'code pane menu' stamp: 'tak 5/14/2004 14:32'!
codePaneMenu: aMenu shifted: shifted
	shifted ifFalse: [
		aMenu addList: #(
			('workspace vars'			inspectWorkspaceVars)
		)].
	super codePaneMenu: aMenu shifted: shifted.
	^ aMenu
! !

!Techo methodsFor: 'private' stamp: 'mu 5/13/2004 18:54'!
collectEntries
	^#()! !

!TechoHowm methodsFor: 'private' stamp: 'mu 5/13/2004 17:49'!
collectEntries
	^ Array
		streamContents: [:aStream | (FileDirectory on: self location)
				withAllNamesAndEntriesDo: [:name :entry | aStream
						nextPut: (TechoFileEntry fileName: name entry: entry)]]! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/17/2004 10:35'!
contents
	^ self selectedEntry
		ifNil: ['']
		ifNotNil: [self selectedEntry contents]! !

!TechoAbee3Entry methodsFor: 'public access' stamp: 'tak 4/18/2004 12:47'!
contents
	^ Text streamContents: [ :s |
s withAttribute: TextEmphasis bold do: [ s nextPutAll: title; cr].
s nextPutAll: date, ' '.
s withAttribute: TextEmphasis bold do: [ s nextPutAll: author; cr; cr].
s nextPutAll: description; cr; cr.
s withAttribute: (PluggableTextAttribute evalBlock: [TechoAbee3 openProjectFromUrl: url]) do: [s nextPutAll: urlText; cr].
]
! !

!TechoEntry methodsFor: 'public access' stamp: 'tak 4/17/2004 21:52'!
contents
	^ ''! !

!TechoFileEntry methodsFor: 'public access' stamp: 'tak 4/26/2004 22:39'!
contents
	| f contents |
	[f := FileStream readOnlyFileNamed: self fileName.
	self setConverterFor: f.
	[contents := self getEntryOn: f]
		ensure: [f
				ifNotNil: [f close]]]
		on: FileDoesNotExistException
		do: [:ex | contents := ''].
	^ contents! !

!TechoHatenaDiaryEntry methodsFor: 'public access' stamp: 'tak 4/17/2004 21:37'!
contents
	| mime |
	mime _ HTTPClient httpGetDocument: url.
	^ (HtmlParser
		parse: (ReadStream on: mime content)) replaceAllTextsToMultiString formattedText asString! !

!TechoEntry methodsFor: 'public access' stamp: 'tak 4/17/2004 21:52'!
contents: aString 
	^ self error: 'not implemented yet'! !

!TechoFileEntry methodsFor: 'public access' stamp: 'tak 4/26/2004 22:39'!
contents: aString 
	| f |
	f _ FileStream forceNewFileNamed: self fileName.
	self setConverterFor: f.
	[Cursor write
		showWhile: [self storeEntryOn: f contents: aString]]
		ensure: [f close].
	self reload.
	^ aString! !

!TechoInfo class methodsFor: 'fileIn/Out' stamp: 'tak 4/21/2004 01:21'!
dateString
	^ ('0' , Date today year asString last: 4)
		, ('0' , Date today monthIndex asString last: 2)
		, ('0' , Date today dayOfMonth asString last: 2)! !

!Techo class methodsFor: 'accessing' stamp: 'tak 4/17/2004 22:15'!
defaultLocation
	^ 'techo'! !

!TechoHatenaDiary class methodsFor: 'accessing' stamp: 'tak 4/17/2004 22:29'!
defaultLocation
	^ 'squeaker'! !

!TechoHowm class methodsFor: 'accessing' stamp: 'tak 4/18/2004 02:41'!
defaultLocation
	^ 'techo'! !

!TechoEntry methodsFor: 'public access' stamp: 'tak 4/17/2004 21:52'!
delete
	^ self error: 'not implemented yet'! !

!TechoFileEntry methodsFor: 'public access' stamp: 'tak 4/17/2004 10:52'!
delete
	(FileDirectory on: self dirName)
		deleteFileNamed: (FileDirectory localNameFor: self fileName)! !

!Techo methodsFor: 'actions' stamp: 'tak 4/20/2004 16:04'!
deleteEntry
	self selectedEntry ifNotNilDo: [:entry | entry delete].
	entries _ nil.
	self changed: #list.
	self changed: #contents.
	self changed: #relabel.
! !

!TechoTest methodsFor: 'Running' stamp: 'tak 4/16/2004 23:28'!
deleteTestDir
	| dirName |
	(FileDirectory default directoryExists: self dir)
		ifTrue: [dirName := FileDirectory default pathName.
			(FileDirectory on: dirName , FileDirectory slash , 'techoTest') recursiveDelete].
! !

!TechoTest methodsFor: 'constants' stamp: 'tak 4/16/2004 23:24'!
dir
	^ self class dir! !

!TechoTest class methodsFor: 'accessing' stamp: 'tak 4/17/2004 01:48'!
dir
	^ 'TechoTest'! !

!TechoFileEntry methodsFor: 'accessing' stamp: 'tak 4/17/2004 10:51'!
dirName
	^ FileDirectory dirPathFor: fileName! !

!Techo methodsFor: 'accessing' stamp: 'mu 5/13/2004 18:01'!
entries
	entries
		ifNil: [entries _ self collectEntries.
			entries _ entries sort: (self sortBlockAt: self sortMode)].
	^ entries! !

!TechoAbee3 methodsFor: 'accessing' stamp: 'tak 4/18/2004 11:07'!
entries
	| url mime html rows |
	entries
		ifNil: [url _ 'http://swikis.ddo.jp/abee/3'.
			mime _ HTTPClient httpGetDocument: url.
			html _ HtmlParser
						parse: (ReadStream on: mime content).
			html replaceAllTextsToMultiString.
			rows _ ((html firstTagNamed: 'body')
						tagsNamed: 'table') third tagsNamed: 'tr'.
			entries _ rows allButFirst
						collect: [:row | TechoAbee3Entry fromHtmlTableRow: row].
			entries _ entries reverse].
	^ entries! !

!TechoHatenaDiary methodsFor: 'accessing' stamp: 'tak 4/17/2004 22:51'!
entries
	| mime dom |
	entries
		ifNil: [mime _ HTTPClient httpGetDocument: self rssUrl.
			dom _ XMLDOMParser
						parseDocumentFrom: (ReadStream on: mime contents).
			entries _ Array
						streamContents: [:aStream | (dom firstTagNamed: #rdf:RDF)
								tagsNamed: #item
								do: [:e | 
									| url summary | 
									summary _ (e firstTagNamed: #title) contents first string convertFromWithConverter: UTF8TextConverter new.
									url _ (e firstTagNamed: #link) contents first string.
									aStream nextPut: (TechoHatenaDiaryEntry new summary: summary;
											 url: url;
											 yourself)]]].
	^ entries! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/24/2004 11:49'!
entries: aCollection
	^ entries _ aCollection! !

!TechoInfo methodsFor: 'naming' stamp: 'tak 5/9/2004 20:43'!
externalName
	^ self hasScamper
		ifTrue: ['Techo+Scamper']
		ifFalse: ['Techo']! !

!TechoFileEntry methodsFor: 'accessing' stamp: 'tak 4/14/2004 07:52'!
fileEntry
	^fileEntry! !

!TechoFileEntry methodsFor: 'accessing' stamp: 'tak 4/11/2004 23:14'!
fileName
	^ fileName! !

!TechoEntry class methodsFor: 'instance creation' stamp: 'tak 4/17/2004 21:50'!
fileName: fileName entry: entry 
	^ self new fileName: fileName entry: entry! !

!TechoFileEntry methodsFor: 'initialization' stamp: 'tak 4/11/2004 23:10'!
fileName: name entry: entry
	fileName _ name.
	fileEntry _ entry! !

!TechoFileEntry class methodsFor: 'instance creation' stamp: 'tak 4/11/2004 23:18'!
fileName: fileName entry: entry 
	^ self new fileName: fileName entry: entry! !

!TechoInfo class methodsFor: 'fileIn/Out' stamp: 'tak 4/21/2004 01:37'!
fileOutAllTecho
	"self fileOutAllTecho"
	| stream |
	self
		fileOutTechoPackage: (PackageInfo named: 'Techo').
	self
		fileOutTechoPackage: (PackageInfo named: 'Techo-Base').
	self fileOutTechoPackage: TechoInfo scamperPackage.
	stream _ FileStream forceNewFileNamed: 'Techo-Base-' , self dateString , '.st'.
	(PackageInfo named: 'Techo-Base')
		fileOutOnStream: stream.
	stream close! !

!TechoInfo class methodsFor: 'fileIn/Out' stamp: 'tak 4/21/2004 01:22'!
fileOutTechoPackage: package 
	SARPackageDumper fileOutPackage: package as: package externalName , '-' , self dateString , '.sar'! !

!Techo methodsFor: 'actions' stamp: 'tak 4/19/2004 01:35'!
filter
	| answer |
	answer _ FillInTheBlank request: 'filter string' initialAnswer: '*'.
	(answer includes: $*)
		ifFalse: [answer _ '*' , answer , '*'].
	entries _ entries
				select: [:each | answer match: each summary].
	self changed: #list! !

!HtmlEntity methodsFor: '*techo-http' stamp: 'tak 4/18/2004 10:01'!
firstTagNamed: aString 
	self
		allSubentitiesDo: [:e | e tagName = aString
				ifTrue: [^ e]].
	^ nil! !

!HtmlEntity methodsFor: '*techo-http' stamp: 'tak 4/18/2004 10:53'!
formattedString
	"return a version of this document as a formatted Text"
	| formatter |
	formatter _ HtmlFormatter preferredFormatterClass new.
	self addToFormatter: formatter.
	^formatter text string withBlanksTrimmed! !

!HtmlEntity methodsFor: '*techo-http' stamp: 'tak 4/18/2004 10:46'!
formattedText
	"return a version of this document as a formatted Text"
	| formatter |
	formatter _ HtmlFormatter preferredFormatterClass new.
	self addToFormatter: formatter.
	^formatter text ! !

!TechoAbee3Entry class methodsFor: 'instance creation' stamp: 'tak 4/18/2004 11:56'!
fromHtmlTableRow: aRow
	| entities |
	entities _ aRow subEntities.

	^ TechoAbee3Entry new
		title: entities first formattedString 
		date: entities second formattedString 
		author: entities third formattedString 
		description: entities fourth formattedString 
		url: (entities fifth contents first href ifNotNilDo: [ :s | 'http://swikis.ddo.jp', s ])
		urlText: entities fifth formattedString ! !

!Time class methodsFor: '*techo-base' stamp: 'tak 5/14/2004 11:00'!
fromStringIso: aString
	^self readFromIso: (ReadStream on: aString)! !

!TechoHatenaDiary class methodsFor: 'accessing' stamp: 'tak 4/17/2004 22:04'!
fullBaseName: aString 
	^ aString! !

!TechoHowm methodsFor: 'utility' stamp: 'tak 4/18/2004 00:10'!
fullPathFor: aString 
	^ (FileDirectory dirPathFor: aString) isEmpty
		ifTrue: [FileDirectory default pathName , FileDirectory slash , aString]
		ifFalse: [aString]! !

!TechoFileEntry methodsFor: 'compatibility' stamp: 'tak 4/17/2004 09:12'!
getEntryOn: aStream 
	^ (aStream respondsTo: #wantsLineEndConversion:)
		ifTrue: [aStream wantsLineEndConversion: true.
			aStream contents]
		ifFalse: [| dist next lf | 
			"CrLf conversion"
			lf := Character lf.
			dist := '' writeStream.
			[aStream atEnd]
				whileFalse: [next := aStream next.
					next = lf
						ifFalse: [dist nextPut: next]].
			dist contents]! !

!Techo methodsFor: 'actions' stamp: 'tak 4/21/2004 00:41'!
getLine: aString interval: anInterval 
	"self new getLine: 'aaa 
bbb ccc ddd eee
fff gg
' interval: (5 to: 7)
	"
	| start aStream line |
	start _ anInterval first - 40.
	start < 0
		ifTrue: [start _ 0].
	aStream _ aString readStream.
	aStream position: start.
	[aStream atEnd]
		whileFalse: [line _ aStream nextLine.
			aStream position > anInterval last
				ifTrue: [^ line]].
	^ line! !

!Techo methodsFor: 'actions' stamp: 'tak 4/24/2004 20:06'!
grep
	| query result answers newTecho |
	query _ FillInTheBlank request: 'grep word' initialAnswer: ''.
	query isEmpty
		ifTrue: [^ self].
	[result _ Array
				streamContents: [:strm | self entries
						do: [:entry | 
							answers _ self grep: query from: entry.
							answers notNil
								ifTrue: [strm nextPutAll: answers]]].
	result isEmpty
		ifFalse: [newTecho _ self copy breakDependents.
			newTecho entries: result.
			WorldState
				addDeferredUIMessage: [newTecho buildWindow openInWorld]]]
		forkAt: Processor userBackgroundPriority! !

!Techo methodsFor: 'actions' stamp: 'tak 4/21/2004 01:01'!
grep: aString from: entry 
	| source index found result interval |
	source _ entry contents.
	index _ 1.
	result _ Array
				streamContents: [:strm | [(found _ source findString: aString startingAt: index) > 1]
						whileTrue: ["Transcript show: entry summary; show: found printString; cr."
							interval _ found to: found + aString size - 1.
							strm nextPut: ((entry class newFrom: entry) selectionInterval: interval;
									
									summary: (self getLine: source interval: interval);
									 yourself).
							index _ found + aString size]].
	^ result! !

!TechoInfo methodsFor: 'testing' stamp: 'tak 5/9/2004 20:43'!
hasScamper
	^ self prerequisiteChangeSets includesSubstringAnywhere: 'Scamper'! !

!TechoFileEntry methodsFor: 'public access' stamp: 'tak 4/26/2004 22:41'!
headLine
	| f |
	[f _ FileStream readOnlyFileNamed: self fileName.
	self setConverterFor: f.
	summary _ f nextLine]
		ensure: [f
				ifNotNil: [f close]].
	^ summary
		ifNil: [''
			", ' ('  
			, (self localName copyFrom: 6 to: 10) , ')' 
			"]! !

!Techo class methodsFor: 'experimental' stamp: 'tak 4/17/2004 19:12'!
httptest
	"self httptest"
	| url mime |
	url _ 'http://d.hatena.ne.jp/squeaker/'.
	mime _ HTTPClient httpGetDocument: url.
	^(HtmlParser parse: (ReadStream on: mime content))  replaceAllTextsToMultiString formattedText
! !

!TechoAbee3 class methodsFor: 'experimental' stamp: 'tak 4/18/2004 10:34'!
httptest
	"self httptest"
	| url mime |
	url _ 'http://swikis.ddo.jp/abee/3'.
	mime _ HTTPClient httpGetDocument: url.
	Src _ (HtmlParser parse: (ReadStream on: mime content)).
	Src replaceAllTextsToMultiString.
	Src subEntities.
	TechoAbee3Entry fromHtmlTableRow: (((Src firstTagNamed: 'body') tagsNamed: 'table') third tagsNamed: 'tr') second! !

!TechoHatenaDiary class methodsFor: 'experimental' stamp: 'tak 4/18/2004 09:51'!
httptest
	"self httptest"
	| url mime |
	url _ 'http://d.hatena.ne.jp/squeaker/'.
	mime _ HTTPClient httpGetDocument: url.
	^(HtmlParser parse: (ReadStream on: mime content))  replaceAllTextsToMultiString formattedText
! !

!Techo methodsFor: 'initialization' stamp: 'mu 5/13/2004 18:47'!
initSortBlocks
	sortBlocks _ IdentityDictionary new.
	sortBlocks at: #name put: [:a :b | a summary < b summary].
	sortBlocks at: #time put: [:a :b | a modificationTime > b modificationTime].
	^sortBlocks

! !

!Techo methodsFor: 'constants' stamp: 'tak 4/12/2004 23:28'!
initialExtent
	^ 350 @ 350! !

!Techo class methodsFor: 'class initialization' stamp: 'tak 4/17/2004 22:18'!
initialize
	"self initialize"
	location _ nil.
	(TheWorldMenu respondsTo: #registerOpenCommand:)
		ifTrue: [TheWorldMenu registerOpenCommand: {'Techo'. {Techo. #open}}]! !

!Techo methodsFor: 'initialization' stamp: 'mu 5/13/2004 18:12'!
initialize
	super initialize.
	listIndex _ 0.
	sortMode _ #time.
	! !

!TechoInfo class methodsFor: 'class initialization' stamp: 'tak 5/1/2004 22:50'!
initialize
	self addMethodForMultiByteFileStream! !

!Techo class methodsFor: 'class initialization' stamp: 'tak 4/18/2004 02:22'!
initializeAll
	"self initializeAll"
	self initialize.
	self allSubclassesDo: [ :aClass | aClass initialize ]! !

!Techo methodsFor: 'location' stamp: 'tak 4/18/2004 09:06'!
inputLocation
	| answer |
	answer _ self privateInputLocation.
	answer isEmpty
		ifTrue: [Error signal: 'bad input']
		ifFalse: [^ answer]! !

!Techo methodsFor: 'actions' stamp: 'tak 5/14/2004 14:31'!
inspectWorkspaceVars 
	bindings inspect! !

!TechoEntry methodsFor: 'testing' stamp: 'tak 4/17/2004 21:50'!
isSourceChanged
	^ false! !

!TechoFileEntry methodsFor: 'testing' stamp: 'tak 4/17/2004 11:58'!
isSourceChanged
	| mtime |
	mtime _ ((FileDirectory on: self dirName)
				entryAt: (FileDirectory localNameFor: self localName)
				ifAbsent: [^ true]) modificationTime.
	^ mtime ~= fileEntry modificationTime! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/20/2004 16:07'!
labelString
	^ self selectedEntry
		ifNil: ['Techo']
		ifNotNil: [self selectedEntry summary]! !

!Techo methodsFor: 'constants' stamp: 'tak 4/19/2004 01:35'!
limit
	^ 100! !

!TechoAbee3 methodsFor: 'constants' stamp: 'tak 4/18/2004 13:45'!
limit
	^ 500! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/13/2004 23:34'!
list
	^self summaries! !

!Techo methodsFor: 'updating' stamp: 'tak 4/17/2004 09:45'!
listChanged
	self changed: #list
"	[self changed: #list]
		forkAt: Processor userBackgroundPriority"! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/11/2004 22:29'!
listIndex
	^listIndex! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/20/2004 16:01'!
listIndex: index
	listIndex _ index.
	self changed: #listIndex.
	self changed: #contents.
	self changed: #relabel.
! !

!TechoHatenaDiary methodsFor: 'accessing' stamp: 'tak 4/17/2004 22:41'!
listIndex: index
	listIndex _ index.
	self changed: #listIndex.
	[self changed: #contents] fork.! !

!Techo methodsFor: 'menu' stamp: 'mu 5/13/2004 18:18'!
listMenu: aMenu
	
	aMenu addList: #(
		-
		('filter ...' 		filter)
		('grep ...' 		grep)
	).
	
	self sortMenu: aMenu.
	
	^ aMenu
! !

!TechoAbee3 methodsFor: 'menu' stamp: 'tak 4/21/2004 01:10'!
listMenu: aMenu
	aMenu addList: #(
		('reload'			listResetChanged)
	).
	^ super listMenu: aMenu
! !

!TechoHatenaDiary methodsFor: 'menu' stamp: 'tak 4/21/2004 01:10'!
listMenu: aMenu
	aMenu addList: #(
		('reload'			listResetChanged)
		('hatena id' 		setupLocation)
	).
	^ super listMenu: aMenu
! !

!TechoHowm methodsFor: 'menu' stamp: 'tak 4/19/2004 01:33'!
listMenu: aMenu
	aMenu addList: #(
		('reload'			listResetChanged)
		('delete'			deleteEntry)
		('set directory' 		setupLocation)
	).
	^ super listMenu: aMenu
! !

!Techo methodsFor: 'updating' stamp: 'tak 4/17/2004 12:24'!
listResetChanged
	entries _ nil.
	self entries notEmpty
		ifTrue: [listIndex _ 1].
	self changed: #list.
	self changed: #contents! !

!TechoHatenaDiary methodsFor: 'updating' stamp: 'tak 4/18/2004 09:16'!
listResetChanged
	entries _ nil.
	[self entries notEmpty
		ifTrue: [listIndex _ 1].
	self changed: #list.
	self changed: #contents] fork! !

!TechoFileEntry methodsFor: 'accessing' stamp: 'tak 4/13/2004 09:47'!
localName
	^ FileDirectory localNameFor: self fileName! !

!Techo methodsFor: 'location' stamp: 'tak 4/18/2004 08:41'!
location
	^ location
		ifNil: [self class location
				ifNil: [self location: self inputLocation]]! !

!Techo class methodsFor: 'accessing' stamp: 'tak 4/18/2004 08:42'!
location
	^ location
! !

!Techo class methodsFor: 'accessing' stamp: 'tak 4/18/2004 00:07'!
location: aString 
	^ location _ aString! !

!Techo methodsFor: 'location' stamp: 'tak 4/18/2004 08:39'!
location: aString 
	aString
		ifNotNil: [^ self privateLocation: aString]! !

!Techo methodsFor: 'actions' stamp: 'tak 4/13/2004 23:42'!
makeNewEntry
	self newEntry.
	self contentsChanged.
! !

!TechoEntry methodsFor: 'public access' stamp: 'tak 4/17/2004 21:52'!
modificationTime
	^ self error: 'not implemented yet'! !

!TechoFileEntry methodsFor: 'public access' stamp: 'tak 4/11/2004 23:13'!
modificationTime
	^ fileEntry modificationTime! !

!Techo methodsFor: 'private' stamp: 'tak 4/17/2004 23:01'!
newEntry
	^ self subclassResponsibility ! !

!TechoHowm methodsFor: 'private' stamp: 'tak 5/14/2004 11:01'!
newEntry
	^ self newEntryFor: Time dateAndTimeNow! !

!TechoHowm methodsFor: 'private' stamp: 'tak 4/17/2004 22:57'!
newEntryFor: aTimeStamp 
	| newFullPath localName dir |
	newFullPath := self location , FileDirectory slash
				, (self newFileNameFor: aTimeStamp).
	localName := FileDirectory localNameFor: newFullPath.
	dir := (FileDirectory
				on: (FileDirectory dirPathFor: newFullPath)) assureExistence; yourself.
	(dir newFileNamed: localName) close.
	^ TechoFileEntry
		fileName: newFullPath
		entry: (DirectoryEntry
				name: localName
				creationTime: nil
				modificationTime: nil
				isDirectory: false
				fileSize: 0)! !

!TechoHowm methodsFor: 'private' stamp: 'tak 5/14/2004 11:01'!
newFileNameFor: dateAndTime
	"self new newFileName"
	| date dir time |
	date _ dateAndTime first printFormat: #(3 2 1 $- 1 1 2).
	dir _ (dateAndTime first printFormat: {3. 2. 1. FileDirectory slash first. 1. 1. 2.}) allButLast:2.
	time _ (('0', dateAndTime second hours asString) last: 2),
	(('0', dateAndTime second minutes asString) last:2),
	(('0', dateAndTime second seconds asString)last:2).
	^ dir, date, '-', time, '.howm'.
! !

!Techo class methodsFor: 'instance creation' stamp: 'tak 4/18/2004 01:30'!
on: aString 
	| techo |
	techo _ (self = Techo
				ifTrue: [TechoHowm]
				ifFalse: [self]) new.
	^ (techo location: aString)
		ifNotNil: [techo]! !

!Techo class methodsFor: 'instance creation' stamp: 'mu 5/13/2004 18:49'!
open
	(self on: nil)
		ifNotNilDo: [:techo | ^techo open]! !

!Techo methodsFor: 'initialization' stamp: 'tak 4/17/2004 23:16'!
open
	self openAsMorphLabel: 'Techo'! !

!TechoAbee3 methodsFor: 'initialization' stamp: 'tak 4/18/2004 13:44'!
open
	[ super open ] fork! !

!TechoHatenaDiary methodsFor: 'initialization' stamp: 'tak 4/18/2004 09:19'!
open
	[ super open ] fork! !

!Techo methodsFor: 'initialization' stamp: 'tak 4/18/2004 00:40'!
openAsMorphLabel: labelString 
	| window |
	window _ self buildWindow setLabel: labelString.
	window openInWorld.
	window startStepping.
	^ window! !

!TechoAbee3 class methodsFor: 'utility' stamp: 'tak 4/18/2004 12:44'!
openProjectFromUrl: aString 
	"self openProjectFromUrl: 'http://swikis.ddo.jp/abee/uploads/3/Chase.pr'"
	| localName f |
	localName _ (aString findTokens: '/') last.
	f _ (FileStream fileNamed: localName) binary.
	ComplexProgressIndicator new targetMorph: nil;
		 historyCategory: 'project loading';
		
		withProgressDo: [ProgressNotification signal: '1: get file from network'.
			[f nextPutAll: (HTTPClient httpGetDocument: aString) contents]
				ensure: [f close]].
	ProjectLoading openFromDirectory: FileDirectory default andFileName: localName! !

!TechoInfo methodsFor: 'naming' stamp: 'tak 4/19/2004 22:57'!
packageName
	^'Techo'! !

!TechoInfo methodsFor: 'introspection' stamp: 'tak 4/19/2004 23:16'!
prerequisiteChangeSets
	^ prerequisiteChangeSets
		ifNil: [#()]! !

!TechoInfo methodsFor: 'introspection' stamp: 'tak 4/19/2004 23:16'!
prerequisiteChangeSets: aSet
	prerequisiteChangeSets _ aSet
! !

!TechoFileEntry methodsFor: 'printing' stamp: 'tak 4/14/2004 08:01'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(;
		nextPutAll: self localName;
		nextPut: $)! !

!TechoHatenaDiaryEntry methodsFor: 'printing' stamp: 'tak 4/17/2004 21:05'!
printOn: aStream
	aStream 
		nextPutAll: self summary
! !

!Techo methodsFor: 'location' stamp: 'tak 4/18/2004 09:06'!
privateInputLocation
	"This is used for unit test"
	^ 'answer from fill in the blank'.! !

!TechoHatenaDiary methodsFor: 'location' stamp: 'tak 4/18/2004 09:10'!
privateInputLocation
	^ FillInTheBlank
		request: 'hatena id?'
		initialAnswer: (location
				ifNil: [self class defaultLocation])! !

!TechoHowm methodsFor: 'location' stamp: 'tak 4/18/2004 09:07'!
privateInputLocation
	^ FillInTheBlank
		request: 'directory?'
		initialAnswer: (location
				ifNil: [FileDirectory default pathName , FileDirectory slash , self class defaultLocation])! !

!Techo methodsFor: 'location' stamp: 'tak 4/18/2004 00:08'!
privateLocation: aString
	location _ aString.
	self class location: aString.
	^ aString! !

!TechoHowm methodsFor: 'private' stamp: 'tak 4/18/2004 00:10'!
privateLocation: aString 
	^ super privateLocation: (self fullPathFor: aString).
! !

!Time class methodsFor: '*techo-base' stamp: 'tak 5/14/2004 10:59'!
readFromIso: aStream
	"TimeStamp readFromIso: (ReadStream on: '2004-04-15 08:15:00')"
	| year month day time |
	year _ Integer readFrom: aStream.
	(aStream peekFor: $-).
	month _ Integer readFrom: aStream.
	(aStream peekFor: $-).
	day _ Integer readFrom: aStream.
	aStream skipSeparators.
	time _ Time readFrom: aStream.
	^Array with: (Date newDay: day month: month year: year) with:  time.
! !

!TechoInfo methodsFor: 'introspection' stamp: 'tak 5/9/2004 21:11'!
readmeText
	"self new readmeText"
	^ String
		streamContents: [:s | 
			s nextPutAll:
'Techo is a simple notebook.
Techo open.					"Standard techo"
'.
			self hasScamper
				ifTrue: [s nextPutAll:
'TechoAbee3 open.			"Project okiba"
TechoHatenaDiary open.		"Hatena diary"

Scamper open				"Nihongo Scamper"
']]! !

!TechoEntry methodsFor: 'public access' stamp: 'tak 4/17/2004 21:50'!
reload
! !

!TechoFileEntry methodsFor: 'accessing' stamp: 'tak 4/17/2004 11:21'!
reload
	fileEntry _ (FileDirectory on: self dirName)
				entryAt: self localName
				ifAbsent: ["can't reload"
					^ self]! !

!TechoHatenaDiary methodsFor: 'accessing' stamp: 'tak 4/17/2004 22:21'!
rssUrl
	^ 'http://d.hatena.ne.jp/', self location, '/rss'! !

!Techo class methodsFor: 'experimental' stamp: 'tak 4/17/2004 19:25'!
rsstest
	"self rsstest"
	| url mime |
	url _ 'http://d.hatena.ne.jp/squeaker/rss'.
	mime _ HTTPClient httpGetDocument: url.
	^(XMLDOMParser  parseDocumentFrom:  (ReadStream on: (mime contents))
)! !

!TechoHatenaDiary class methodsFor: 'experimental' stamp: 'tak 4/18/2004 09:51'!
rsstest
	"self rsstest"
	| url mime |
	url _ 'http://d.hatena.ne.jp/squeaker/rss'.
	mime _ HTTPClient httpGetDocument: url.
	^(XMLDOMParser  parseDocumentFrom:  (ReadStream on: (mime contents))
)! !

!TechoInfo class methodsFor: 'instance creation' stamp: 'tak 7/7/2004 09:58'!
scamperPackage
"Includes ...
Scamper
http://map1.squeakfoundation.org/sm/accountbyid/a6930213-b578-49b1-862e-228cc5ab39e7/files/Scamper-md.3.mcz
http://map1.squeakfoundation.org/sm/accountbyid/a6930213-b578-49b1-862e-228cc5ab39e7/files/Network-HTML-md.3.mcz

ScamperScript
http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-June/001658.html
ScamperScript.2.cs

http://ich.homelinux.net:8080/squeak/uploads/48/ScamperBugFix.2.cs
http://ich.homelinux.net:8080/squeak/uploads/NihongoScamper.1.cs

http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-April/001433.html
ZipArchiveMember-compressDataTo

http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-April/001549.html
withSeparatorsCompacted-tak

ScamperWorkspace-2004-07-05
ScamperFix-20040705
"
	| info |
	info _ self new.
	info prerequisiteChangeSets: #('Network-HTML-md.3' 'Scamper-md.3' 'ScamperScript' 'ScamperBugFix' 'NihongoScamper' 'withSeparatorsCompacted-tak' 'ZipArchiveMember-compressDataTo' 'ScamperWorkspace-20040707' 'ScamperFix-20040705').
	^ info! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/11/2004 23:39'!
selectedEntry
	^ self entries at: self listIndex ifAbsent: [^nil]! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/21/2004 00:22'!
selectionInterval
	self selectedEntry
		ifNil: [^ 0 to: 0].
	^ self selectedEntry selectionInterval
		ifNil: [0 to: 0]! !

!TechoEntry methodsFor: 'accessing' stamp: 'tak 4/20/2004 23:59'!
selectionInterval
	^ selectionInterval! !

!TechoEntry methodsFor: 'accessing' stamp: 'tak 4/20/2004 23:59'!
selectionInterval: anInterval
	selectionInterval _ anInterval! !

!TechoFileEntry methodsFor: 'compatibility' stamp: 'tak 4/26/2004 22:21'!
setConverterFor: aStream
	| converter |
	(aStream respondsTo: #converter:) ifTrue: [
		converter_ (Smalltalk respondsTo: #systemLanguage)
			ifTrue: [Smalltalk systemLanguage defaultSystemConverter]
			ifFalse: [(Smalltalk at: #ShiftJISTextConverter) new].
		aStream converter:  converter].! !

!TechoTest methodsFor: 'Running' stamp: 'tak 4/16/2004 22:13'!
setUp
	self deleteTestDir! !

!Techo methodsFor: 'actions' stamp: 'tak 4/18/2004 08:44'!
setupLocation
	(self location: self inputLocation)
		ifNotNil: [self listResetChanged]! !

!Techo methodsFor: 'private' stamp: 'mu 5/13/2004 18:20'!
sortBlockAt: aSymbol
	^self sortBlocks at: aSymbol ifAbsent:[self error: 'No such sort mode']! !

!Techo methodsFor: 'accessing' stamp: 'mu 5/13/2004 18:12'!
sortBlocks
	sortBlocks ifNil: [sortBlocks _ self initSortBlocks].
	^ sortBlocks! !

!Techo methodsFor: 'menu' stamp: 'mu 5/13/2004 18:38'!
sortMenu: aMenu 
	| sub item |
	sub _ MenuMorph new defaultTarget: self.
	self sortBlocks keys
		do: [:mode | sub
				addUpdating: #stringForSortModeIs:
				target: self
				selector: #sortMode:
				argumentList: {mode}].
	item _ MenuItemMorph new.
	item contents: 'sort';
		 subMenu: sub.
	item arguments: #().
	aMenu addMorphBack: item.
	^ aMenu! !

!Techo methodsFor: 'accessing' stamp: 'mu 5/13/2004 18:13'!
sortMode
	sortMode ifNil: [sortMode _ #time].
	^ sortMode! !

!Techo methodsFor: 'accessing' stamp: 'mu 5/13/2004 18:42'!
sortMode: aSymbol
	sortMode _ aSymbol.
	entries _ nil.
	self changed: #list.
	self changed: #contents.
	self changed: #relabel.! !

!Techo methodsFor: 'stepping and presenter' stamp: 'tak 4/18/2004 13:41'!
stepIn: aSystemWindow 
	^ self! !

!TechoHowm methodsFor: 'stepping and presenter' stamp: 'tak 4/18/2004 13:41'!
stepIn: aSystemWindow 
	| entry |
	entry _ self selectedEntry.
	(entry notNil
			and: [entry isSourceChanged])
		ifTrue: [self selectedEntry reload.
			self hasUnacceptedEdits
				ifTrue: [self changed: #codeChangedElsewhere]
				ifFalse: [self contentsChanged]]! !

!Techo methodsFor: 'stepping and presenter' stamp: 'tak 4/17/2004 11:46'!
stepTimeIn: aSystemWindow
	^2000! !

!TechoFileEntry methodsFor: 'compatibility' stamp: 'tak 4/17/2004 00:36'!
storeEntryOn: aStream contents: aString 
	(aStream respondsTo: #lineEndConvention:)
		ifTrue: [aStream lineEndConvention: aStream class lineEndDefault.
			aStream nextPutAll: aString asString]
		ifFalse: [| source next cr | 
			"CrLf conversion"
			cr := Character cr.
			source := aString readStream.
			[source atEnd]
				whileFalse: [next := source next.
					next = cr
						ifTrue: [aStream nextPutAll: String crlf]
						ifFalse: [aStream nextPut: next]]]! !

!Techo methodsFor: 'menu' stamp: 'mu 5/13/2004 18:09'!
stringForSortModeIs: aSym
	
	^ (self sortMode == aSym
		ifTrue: 	['<yes>']
		ifFalse:	['<no>']), ' ', aSym! !

!Techo methodsFor: 'accessing' stamp: 'tak 4/13/2004 23:37'!
summaries
	^ (self entries size > self limit
		ifTrue: [entries first: self limit]
		ifFalse: [entries])
		collect: [:each | [each summary]
				on: Error
				do: [:ex | '???']]! !

!TechoAbee3Entry methodsFor: 'public access' stamp: 'tak 4/18/2004 11:01'!
summary
	^ title! !

!TechoEntry methodsFor: 'public access' stamp: 'tak 4/20/2004 23:57'!
summary
	^ summary! !

!TechoFileEntry methodsFor: 'public access' stamp: 'tak 4/21/2004 00:10'!
summary
	^ selectionInterval
		ifNil: [self headLine]
		ifNotNil: [summary]! !

!TechoEntry methodsFor: 'accessing' stamp: 'tak 4/20/2004 23:56'!
summary: aString
	^ summary _ aString! !

!HtmlEntity methodsFor: '*techo-http' stamp: 'tak 4/18/2004 10:09'!
tagsNamed: aString 
	^ self subEntities
		select: [:e | e tagName = aString]! !

!TechoTest methodsFor: 'Running' stamp: 'tak 4/16/2004 22:13'!
tearDown
	self deleteTestDir! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:00'!
testAccept
	| techo |
	techo _ Techo on: self dir.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 08:30:00')) contents: 'contents'.
	techo acceptContents: 'new line'.
	self assert: techo selectedEntry contents = 'new line'! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:02'!
testCancel
	"For bug of cancel mechanism (maybe). contents can't use as cache"
	| techo |
	techo _ Techo on: 'TechoTest'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 08:30:00')) contents: 'contents'.
	techo listIndex: 1.
	self assert: techo contents = 'contents'.
	techo contents: 'modified'. "direct setter"
	self assert: techo contents = 'contents'.
! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:08'!
testDeleteEntry
	| techo |
	techo _ Techo on: 'TechoTest'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-14 08:30:00')) contents: 'line1'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-13 08:30:00')) contents: 'line2'.
	techo listIndex: 1.
	techo deleteEntry.
	techo listIndex: 1.
	self assert: techo selectedEntry contents = 'line2'.
! !

!TechoTest methodsFor: 'techoEntry test' stamp: 'tak 5/14/2004 11:11'!
testDeleted
	| techo |
	techo _ Techo on: 'TechoTest'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 08:30:00')) contents: 'exist'.
	techo listIndex: 1.
	self assert: techo selectedEntry contents = 'exist'.
	techo selectedEntry delete.
	self assert: techo selectedEntry contents = ''.
! !

!TechoTest methodsFor: 'techoEntry test' stamp: 'tak 5/14/2004 11:20'!
testEntries
	| techo |
	techo _ Techo on: 'TechoTest'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 08:30:00')) contents: 'first'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 12:25:00')) contents: 'second'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 18:00:30')) contents: 'third'.
	self assert: techo entries size = 3.
	self assert: ('*083000*' match: (techo entries last fileEntry name)).
	self assert: ('*third*' match: techo list first).
! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:17'!
testList
	| techo |
	techo _ Techo on: 'TechoTest'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 08:30:00')) contents: 'first'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 12:25:00')) contents: 'second'.
	(techo newEntryFor: (Time fromStringIso: '2004-04-12 18:00:30')) contents: 'third'.
	techo listIndex: 0.
	self assert: techo contents = ''.
	techo listIndex: 1.
	self assert: techo contents = 'third'.
	techo listIndex: 3.
	self assert: techo contents = 'first'.
! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:09'!
testNewEntry
	| techo entry |
	techo _ Techo on: 'techoTest'.
	entry _ techo newEntryFor: (Time fromStringIso: '2004-04-12 22:25:00').
	self assert: (FileDirectory localNameFor: entry fileName) = '2004-04-12-222500.howm'
! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:10'!
testNewFileName
	^ self assert: (TechoHowm new
			newFileNameFor: (Time fromStringIso: '2004-04-12 22:25:00'))
			= '2004\04\2004-04-12-222500.howm'! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 4/17/2004 22:21'!
testNewInstance
	| techo |
	techo _ Techo on: 'TechoTest'.
	self assert: (FileDirectory localNameFor: techo location) = 'TechoTest'.! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 4/18/2004 08:43'!
testOpen
	| techo |
	"When location is not initialized"
	Techo initialize.
	techo _ Techo new.
	self assert: techo location = 'answer from fill in the blank'.

	"When location is initialized by nil"
	Techo initialize.
	techo _ Techo new.
	techo location: nil.
	self assert: techo location = 'answer from fill in the blank'.

	"When location is initialized explicitly"
	techo _ Techo new.
	techo location: 'first'.
	self assert: techo location = 'first'.

	"Location is initialized by last value"
	techo _ Techo new.
	techo location: nil.
	self assert: techo location = 'first'.

	"Set up"
	techo _ Techo new.
	techo location: techo inputLocation.
	self assert: techo location = 'answer from fill in the blank'! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:50'!
testPathName
	| techo entry |
	techo _ Techo on: 'techoTest'.
	entry _ techo newEntryFor: (Time fromStringIso: '2004-04-12 22:25:00').
	self assert: entry localName = '2004-04-12-222500.howm'! !

!TechoTest methodsFor: 'techoEntry test' stamp: 'tak 5/14/2004 11:51'!
testReload
	| techo techo2 |
	techo _ Techo on: self dir.
	techo2 _ Techo on: self dir.
	techo newEntryFor: (Time fromStringIso: '2004-04-12 08:30:00').
	techo entries first contents: 'modified'.
	(Delay forMilliseconds: 1000) wait.
	techo2 entries first contents: 'modified'.
	self assert: techo entries first isSourceChanged.
	techo entries first reload.
	self assert: techo entries first isSourceChanged not.
! !

!TechoTest methodsFor: 'techoEntry test' stamp: 'tak 5/14/2004 11:50'!
testSummary
	| techo entry |
	techo _ Techo on: 'techoTest'.
	entry _ techo newEntryFor: (Time fromStringIso: '2004-04-12 22:25:00').
	entry contents: 'line'.
	self assert: entry summary = 'line'.
"	self assert: (entry summary first: 6) = '04-12'"! !

!TechoTest methodsFor: 'techo test' stamp: 'tak 5/14/2004 11:51'!
testTimeStamp
	| stamp |
	stamp _ Time fromStringIso: '2004-04-14 08:30:00' .
	self assert: stamp first year = 2004.
	self assert: stamp first monthIndex = 4.
	self assert: stamp second hours = 8.
	self assert: stamp second minutes = 30.
! !

!TechoAbee3Entry methodsFor: 'initialize' stamp: 'tak 4/18/2004 10:30'!
title: title0 date: date0 author: author0 description: description0 url: url0 urlText: urlText0
	title _ title0.
	date _ date0.
	author _ author0.
	description _ description0.
	url _ url0.
	urlText _ urlText0! !

!TechoInfo class methodsFor: 'uninstall' stamp: 'tak 5/1/2004 22:52'!
uninstall
	| changes |
	TechoInfo default extensionMethods
		do: [:each | each actualClass removeSelector: each methodSymbol].
	TechoInfo default classes
		do: [:each | each removeFromSystem].
	changes _ ChangeSorter allChangeSets
				select: [:each | 'Techo*' match: each name].
	changes
		do: [:each | ChangeSorter removeChangeSet: each]! !

!TechoHatenaDiaryEntry methodsFor: 'accessing' stamp: 'tak 4/17/2004 20:37'!
url
	^ url! !

!TechoHatenaDiaryEntry methodsFor: 'accessing' stamp: 'tak 4/17/2004 20:37'!
url: aString
	^ url _ aString! !

!FileDirectory methodsFor: '*techo-base' stamp: 'tak 4/11/2004 22:43'!
withAllNamesAndEntriesDo: namesAndEntriesBlock 
	"(Array streamContents: [:strm |
		(FileDirectory on: 'c:\windows\fonts')
			withAllNamesAndEntriesDo: [:n :ent | strm nextPut: n -> ent]]) inspect."
	| todo dir |
	todo _ OrderedCollection with: self.
	[todo size > 0]
		whileTrue: [dir _ todo removeFirst.
			dir entries select: [:entry | entry isDirectory not ]
				thenCollect: [:entry | namesAndEntriesBlock
						value: (dir fullNameFor: entry name)
						value: entry].
			dir directoryNames
				do: [:n | todo
						add: (dir directoryNamed: n)]]! !
Techo initialize!
TechoInfo initialize!
